package com.deadsoftware;

import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Random;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.GameCanvas;
import javax.microedition.midlet.MIDlet;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;

public class REPENT extends MIDlet{

    private final Display display;
    private final Application application;
    private final Random rnd;
    
    public REPENT(){
        
        rnd=new Random();
        application=new Application();
        display=Display.getDisplay(this);
    }
    
    public void putLvl(byte lvl){
        
        RecordStore rms=null;
        byte[] b=new byte[]{
                
                lvl
        };
        try{
            
            rms=RecordStore.openRecordStore("REPENT",true);
            rms.setRecord(1,b,0,1);
            rms.closeRecordStore();
        }catch(RecordStoreException rse){
            
            try{
                
                rms.addRecord(b,0,1);
                rms.closeRecordStore();
            }catch(RecordStoreException rsee){
                
                exception(rsee);
            }
        }
    }
    
    public byte getLvl(){
        
        byte lvl=0;
        try{
            
            RecordStore rms=RecordStore.openRecordStore("REPENT",true);
            lvl=rms.getRecord(1)[0];
            rms.closeRecordStore();
        }catch(Exception rse){
            
            putLvl(lvl);
        }
        return lvl;
    }
    
    public void startApp(){
        
        display.setCurrent(application);
        application.start();
    }
    
    public void pauseApp(){
        
        
    }
    
    public void destroyApp(boolean unconditional){
        
        
    }

    public void exception(Exception e) {
        System.out.println(e.getMessage());
        e.printStackTrace();
        for(;;);
    }
    
        
    private class Application extends GameCanvas implements Runnable{
        
        private final Graphics graph;
        private final Thread thread;
        private final int scrx; //ширина экрана
        private final int scry; //высота экрана
        private int kc; //нажатая один раз кнопка
        public final MainMenu menu;
        
        public Application(){
         
            super(false);
            this.setFullScreenMode(true);
            thread=new Thread(this);
            graph=this.getGraphics();
            scrx=this.getWidth();
            scry=this.getHeight();
            menu=new MainMenu();
        }
        
        //запустить игру!
        public void start(){
            
            thread.start();
        }
        
        public void keyPressed(int keyCode){
            
            kc=keyCode;
        }
        
        public void run(){
         
            new Splash("/gfx/Splash.png").run();
            new History("/history.txt").run();
            System.gc();
            menu.run();
        }
        
        private class History{
            
            private final MultiString text;
            private int posy;
            
            public History(String path){
                
                StringBuffer sb=new StringBuffer();
                try{
                    
                    InputStream is=getClass().getResourceAsStream(path);
                    while(is.available()>0){
                        
                        int c=is.read();
                        //if(c>=1040&&c<=1104)c-=848;
                        sb.append((char)((c>=0xc0&&c<=0xFF)?(c+0x350):c));
                    }
                    is.close();
                }catch(IOException ioe){
                    
                    exception(ioe);
                }
                text=new MultiString(sb.toString());
                posy=scry;//-(text.getLength(scrx,scry)*
                       // Font.getDefaultFont().getHeight());
            }
            
            public void run(){
                
                while(posy>(-(text.getLength(scrx,scry)*
                        Font.getDefaultFont().getHeight()))){
                    
                    graph.setColor(0);
                    graph.fillRect(0,0,scrx,scry);
                    graph.setColor(0xffffff);
                    text.paint(graph,0,posy,scrx,scry);
                    flushGraphics();
                    posy--;
                }
            }
        }
        
        private class Splash{
            
            private SImage splash;
            
            public Splash(String path){
                
                try{
                    
                    Image spl=Image.createImage(path);
                    splash=SImage.createSImage(spl,(scrx-spl.getWidth())/2,
                            (scry-spl.getHeight())/2);
                }catch(IOException ioe){
                    
                    exception(ioe);
                }
            }
            
            public void run(){
                
                graph.setColor(0);
                graph.fillRect(0,0,scrx,scry);
                splash.paint(graph);
                flushGraphics();
                try{
                    
                    Thread.sleep(5000);
                }catch(InterruptedException ie){
                    
                    exception(ie);
                }
            }
        }
        
        private class MainMenu{
            
            private final About about;
            private final Game game;
            private final GameOver go;
            private SImage logo;
            private final SImage[] choise;
            private final SImage[] selectChoise;
            private int position;
            private final Pause pause;
            private final Win win;
            
            public MainMenu(){
                
                win=new Win();
                go=new GameOver();
                pause=new Pause();
                position=0;
                about=new About();
                game=new Game();
                choise=new SImage[4];
                selectChoise=new SImage[4];
                try{
                    
                    logo=SImage.createSImage("/gfx/Repent.png",(scrx-105)/2,5);
                    Image menu=Image.createImage("/gfx/Menu.png");
                    for(int i=0;i<4;i++){
                        
                        choise[i]=SImage.createSImage(
                                Image.createImage(menu,0,i*24,114,24,0),
                                (scrx-114)/2,
                                50+i*26);
                        selectChoise[i]=SImage.createSImage(
                                Image.createImage(menu,0,96+i*24,114,24,0),
                                (scrx-114)/2,
                                50+i*26);
                    }
                }catch(IOException ioe){
                    
                    exception(ioe);
                }
            }
            
            public void run(){
                
                while(true){
                    
                    graph.setColor(0);
                    graph.fillRect(0,0,scrx,scry);
                    logo.paint(graph);
                    for(int i=0;i<4;i++){
                    
                        if(i==position){
                        
                            selectChoise[i].paint(graph);
                        }else{
                        
                            choise[i].paint(graph);
                        }
                    }
                    keyPress();
                    flushGraphics();
                    try{
                    
                        Thread.sleep(1);
                    }catch(InterruptedException ie){
                    
                        exception(ie);
                    }
                }
            }
            
            private void keyPress(){
               
                int key=kc;
                kc=0;
                switch(key){
                        
                    case 50:
                    case -1:
                        position--;
                        if(position<0)position=0;
                        break;
                            
                    case 56:
                    case -2:
                        position++;
                        if(position>3)position=3;
                        break;
                            
                    case 53:
                    case -5:
                        int tmp=position;
                        position=0;
                        switch(tmp){
                            
                            case 0:
                                putLvl((byte)0);
                                game.start(0);
                                break;
                                
                            case 1:
                                game.start(getLvl());
                                break;
                                
                            case 2:
                                about.run();
                                break;
                                
                            case 3:
                                notifyDestroyed();
                        }
                }
            }
        }
        
        private class About{
            
            private SImage logo;
            private SImage back;
            private final SText[] text;
            
            public About(){
                
                String[] txt=new String[]{
                    
                    "Programer: Kalter",
                    "Artist: EudGenius",
                    "Mapper: Kalter",
                    "(c) DeaDSoftWare",
                    "deadsoftware.ru"
                };
                Font fnt=Font.getDefaultFont();
                text=new SText[5];
                for(int i=0;i<5;i++){
                    
                    text[i]=new SText(
                            txt[i],
                            0x00998C,
                            (scrx-fnt.stringWidth(txt[i]))/2,
                            46+fnt.getHeight()*i);
                }
                try{
                    
                    logo=SImage.createSImage("/gfx/About.png",(scrx-84)/2,5);
                    back=SImage.createSImage("/gfx/Back.png",
                            (scrx-27)/2,text[4].y()+20);
                }catch(IOException ioe){
                    
                    exception(ioe);
                }
            }
            
            public void run(){
                
                while(true){
                    
                    int key=kc;
                    kc=0;
                    if((key==GameCanvas.KEY_NUM5)||(key==-5))break;
                    graph.setColor(0);
                    graph.fillRect(0,0,scrx,scry);
                    logo.paint(graph);
                    back.paint(graph);
                    for(int i=0;i<5;i++)text[i].paint(graph);
                    flushGraphics();
                    try{
                    
                        Thread.sleep(1);
                    }catch(InterruptedException ie){
                    
                        exception(ie);
                    }
                }
            }
        }
        
        private class Pause{
         
            private SImage lg;
            private SImage[] choise;
            private SImage[] selectChoise;
            private int position;
            
            public Pause(){
                
                position=0;
                try{
                    
                    lg=SImage.createSImage("/gfx/Pause.png",(scrx-87)/2,5);
                    choise=new SImage[2];
                    selectChoise=new SImage[2];
                    for(int i=0;i<2;i++){
                        
                        choise[i]=SImage.createSImage("/gfx/Pchoise"+i+".png",
                                (scrx-150)/2,50+i*26);
                        selectChoise[i]=SImage.createSImage(
                                "/gfx/SPchoise"+i+".png",
                                (scrx-150)/2,50+i*26);
                    }
                }catch(IOException ioe){
                    
                    exception(ioe);
                }
            }
            
            public int run(){
             
                while(true){
                    
                    graph.setColor(0);
                    graph.fillRect(0,0,scrx,scry);
                    lg.paint(graph);
                    for(int i=0;i<2;i++){
                        
                        if(i==position)selectChoise[i].paint(graph);
                        else choise[i].paint(graph);
                    }
                    flushGraphics();
                    try{
                    
                        Thread.sleep(1);
                    }catch(InterruptedException ie){
                    
                        exception(ie);
                    }
                    int key=kc;
                    kc=0;
                    switch(key){
                        
                        case 50:
                        case -1:
                            position--;
                            if(position<0)position=0;
                            break;
                            
                        case 56:
                        case -2:
                            position++;
                            if(position>1)position=1;
                            break;
                            
                        case 53:
                        case -5:
                            try{
                            
                                return position;
                            }finally{
                                
                                position=0;
                            }
                    }
                }
            }
        }
        
        private class GameOver{
            
            private SImage img;
            
            public GameOver(){
                
                try{
                    
                    img=SImage.createSImage("/gfx/Game_over.png",
                            (scrx-159)/2,
                            (scry-24)/2);
                }catch(IOException ioe){
                    
                    exception(ioe);
                }
            }
            
            public void run(){
                
                graph.setColor(0);
                graph.fillRect(0,0,scrx,scry);
                img.paint(graph);
                flushGraphics();
                try{
                    
                    Thread.sleep(3000);
                }catch(InterruptedException ie){
                    
                    
                }
            }
        }
        
        private class Win{
            
            private Animation[] trup;
            private Animation[] active;
            
            private final byte TRUP=0;
            private final byte ACTIVE=1;
            private final byte NULL=2;
            private final byte SPEC=3;
            
            private Image bg;
            
            private Image bg2;
            private int bg2x;
            
            private Robot[] rob;
            
            private long lastTime;
            
            private SImage end;
            
            public Win(){
                
                try{
                    
                    bg=Image.createImage(scrx,scry);
                    Graphics addbg=bg.getGraphics();
                    addbg.setColor(0x960302);
                    addbg.fillRect(0,0,scrx,scry/5);
                    addbg.setColor(0xB51906);
                    addbg.fillRect(0,scry/5,scrx,scry/5);
                    addbg.setColor(0xD45003);
                    addbg.fillRect(0,scry/5*2,scrx,scry/5);
                    addbg.setColor(0xEF7906);
                    addbg.fillRect(0,scry/5*3,scrx,scry/5);
                    addbg.setColor(0xF2A505);
                    addbg.fillRect(0,scry/5*4,scrx,scry/5);
                    
                    bg2=Image.createImage(scrx,57);
                    Image chbg2=Image.createImage("/gfx/Bg.png");
                    addbg=bg2.getGraphics();
                    for(int i=0;i<scrx;i+=240)addbg.drawImage(chbg2,i,0,0);
                    //Image.createImage("");
                    
                    int length=(scrx+scry)/100;
                    rob=new Robot[length];
                    
                    Image activ=Image.createImage("/gfx/Active.png");
                    Image left=Image.createImage(activ,31,0,32,32,0);
                    Image right=Image.createImage(activ,0,0,32,32,0);
                    
                    active=new Animation[2];
                    active[0]=Animation.createAnimation(left,16,125);
                    active[1]=Animation.createAnimation(right,16,125);
                    
                    Image trp=Image.createImage("/gfx/Trup.png");
                    left=Image.createImage(trp,0,0,160,32,0);
                    right=Image.createImage(trp,159,0,160,32,0);
                    
                    trup=new Animation[2];
                    trup[0]=Animation.createAnimation(left,32,1000);
                    trup[1]=Animation.createAnimation(right,32,1000);
                    
                    end=SImage.createSImage("/gfx/End.png",(scrx-123)/2,scry/3);
                }catch(IOException ioe){
                    
                    exception(ioe);
                }
            }
            
            public void start(){
                
                bg2x=scrx;
                int length=rob.length;
                for(int i=0;i<length;i++)rob[i]=new Robot(
                        Math.abs(rnd.nextInt()%(scrx-32)));
            }
            
            public void run(){
                
                int length=rob.length;
                graph.drawImage(bg,0,0,0);
                graph.drawImage(bg2,0,scry-57,0);
                graph.setColor(0x330101);
                graph.fillRect(0,scry-57,bg2x>0?bg2x--:bg2x,57);
                trup[0].start();
                trup[1].start();
                for(int i=0;i<length;i++)rob[i].run();
                flushGraphics();
                try{
                    
                    Thread.sleep(3000);
                }catch(InterruptedException ie){
                    
                    exception(ie);
                }
                lastTime=System.currentTimeMillis();
                trup[0].start();
                trup[1].start();
                while(is()){
                    
                    graph.drawImage(bg,0,0,0);
                    graph.drawImage(bg2,0,scry-57,0);
                    graph.setColor(0x330101);
                    graph.fillRect(0,scry-57,bg2x>0?bg2x--:bg2x,57);
                    for(int i=0;i<length;i++)rob[i].run();
                    active[0].next();
                    active[1].next();
                    trup[0].next();
                    trup[1].next();
                    flushGraphics();
                    if((System.currentTimeMillis()-lastTime)>5000){
                        
                        for(int i=0;i<length;i++)rob[i].activate();
                    }
                    try{
                    
                        Thread.sleep(1);
                    }catch(InterruptedException ie){
                    
                        exception(ie);
                    }
                }
                for(int i=0;i<length;i++){
                    
                    if(rob[i].vector==0){
                        
                        rob[i].vector=1;
                        rob[i].x=-Math.abs(rnd.nextInt()%(scrx/2));
                    }else{
                        
                        rob[i].vector=0;
                        rob[i].x=Math.abs(rnd.nextInt()%(scrx/2))+scrx;
                    }
                    rob[i].state=SPEC;
                }
                long lt=System.currentTimeMillis();
                while((System.currentTimeMillis()-lt)<10000){
                    
                    graph.drawImage(bg,0,0,0);
                    graph.drawImage(bg2,0,scry-57,0);
                    end.paint(graph);
                    for(int i=0;i<length;i++)rob[i].run();
                    active[0].next();
                    active[1].next();
                    flushGraphics();
                    try{
                    
                        Thread.sleep(1);
                    }catch(InterruptedException ie){
                    
                        exception(ie);
                    }
                }
            }
            
            public boolean is(){
                
                int length=rob.length;
                for(int i=0;i<length;i++)if(rob[i].state!=NULL)return true;
                return false;
            }
            
            private class Robot{
                
                private int x;
                private final int y;
                private byte state;
                private int vector;   //1right 0left
                
                public Robot(int x){
                    
                    y=scry-57-32;
                    this.x=x;
                    state=TRUP;
                    vector=Math.abs(rnd.nextInt()%2);
                }
                
                public void activate(){
                    
                    if(state==ACTIVE||state==NULL)return;
                    state=ACTIVE;
                }
                
                public void run(){
                    
                    switch(state){
                        
                        case TRUP:
                            trup[vector].paint(graph,x,y);
                            break;
                            
                        case ACTIVE:
                            active[vector].paint(graph,x,y);
                            x=vector==1?x+1:x-1;
                            if(((x+16)<0)||(x>scrx))state=NULL;
                            break;
                            
                        case SPEC:
                            active[vector].paint(graph,x,y);
                            x=vector==1?x+1:x-1;
                    }
                }
            }
        }
        
        private class Game{
        
            private Animation[] en_;
            private Image[] en__;
            
            private int finish;
            private final Boom boom;
            private final Lift[] lift;
            private Image deadRobot;
            private final int[] rx;
            private final int[] ry;
            private final boolean[] rt;
            private final Enemy[] en;      //враги
            private Image[] tile;          //тайлы
            private Animation[] gamer;     //анимация игрока
            private Image[] gamer_fire;
            private byte[][] map;          //матрица карты
            private int x;                 //х координата игрока
            private int y;                 //у координата игрока
            private int vector;            //напрваление игрока
            private int lspeedx;           //скорость изменения x игрока влево
            private int rspeedx;           //скорость изменения x игрока вправо
            private boolean jmp;           //состояние прыжка игрока
            private int jspeed;            //скорость прыжка игрока
            private int fall;              //скорость падения игрока
            private final Bullet[] bullet; //все пули
            private int camx;              //камера x
            private int camy;              //камера y
            private int life;
            private boolean end;
            private SImage panel;
            private final Knopka fuck;
        
            public Game(){
            
                fuck=new Knopka(0,0);
                
                end=false;
                
                boom=new Boom();
                
                lift=new Lift[16];
                for(int i=0;i<16;i++)lift[i]=new Lift();
                
                //дохлые роботы
                rx=new int[16];
                ry=new int[16];
                rt=new boolean[16];
                
                //пули
                bullet=new Bullet[32];
                for(int i=0;i<32;i++)bullet[i]=new Bullet();
                
                //вргаи
                en=new Enemy[32];
                for(int i=0;i<32;i++)en[i]=new Enemy();
                try{
                
                    //карта
                    map=new byte[32][64];
                    
                    //тайлы
                    Image tiles=Image.createImage("/gfx/Tile.png");
                    tile=new Image[49];
                    for(int i=1;i<49;i++)tile[i]=Image.createImage(tiles,
                            i*16-16,0,16,16,0);
                    
                    //текстуры для игрока
                    Image robot=Image.createImage("/gfx/Gamer.png");
                    Image left=Image.createImage(robot,0,0,32,32,0);
                    Image right=Image.createImage(robot,31,0,32,32,0);
                    gamer=new Animation[2];
                    gamer[0]=Animation.createAnimation(left,16,125);
                    gamer[1]=Animation.createAnimation(right,16,125);
                    Image robot_fire=Image.createImage("/gfx/Gamer_fire.png");
                    gamer_fire=new Image[2];
                    gamer_fire[0]=Image.createImage(robot_fire,0,0,16,32,0);
                    gamer_fire[1]=Image.createImage(robot_fire,15,0,16,32,0);
                    
                    //текстуры для дохлых робатаф
                    deadRobot=Image.createImage("/gfx/Dead_robot.png");
                    
                    //текстуры для врагов
                    robot=Image.createImage("/gfx/Enemy.png");
                    left=Image.createImage(robot,0,0,32,32,0);
                    right=Image.createImage(robot,31,0,32,32,0);
                    en_=new Animation[2];
                    en_[0]=Animation.createAnimation(left,16,125);
                    en_[1]=Animation.createAnimation(right,16,125);
                    robot_fire=Image.createImage("/gfx/Enemy_fire.png");
                    en__=new Image[2];
                    en__[0]=Image.createImage(robot_fire,0,0,16,32,0);
                    en__[1]=Image.createImage(robot_fire,15,0,16,32,0);
                    
                    //нижняя панель
                    Image pnl=Image.createImage("/gfx/Down_panel.png");
                    panel=SImage.createSImage(
                            Image.createImage(scrx,16),0,scry-16);
                    Graphics apnl=panel.image().getGraphics();
                    for(int i=0;i<scry;i+=128)apnl.drawImage(pnl,i,0,0);
                    apnl.drawImage(Image.createImage("/gfx/Right_panel.png"),
                            scrx-60,0,0);
                }catch(IOException ioe){
                
                    exception(ioe);
                }
            }
            
            public void run(){
            
                while(end){
                    
                    paint();
                    for(int i=0;i<32;i++){
                        
                        en[i].upd();
                        bullet[i].upd();
                    }
                    keyPressed();
                    phyctrl();
                    flushGraphics();
                    try{
                    
                        Thread.sleep(1);
                    }catch(InterruptedException ie){
                    
                        exception(ie);
                    }
                }
            }
            
            //столкновения 16x32 и карты
            private boolean coll(int x,int y){
                
                int x0=x/16;
                int x1=(x+15)/16;
                int y0=y/16;
                int y1=(y+15)/16;
                int y2=(y+31)/16;
                return
                        (map[y0][x0]<25)||
                        (map[y1][x0]<25)||
                        (map[y2][x0]<25)||
                        (map[y0][x1]<25)||
                        (map[y1][x1]<25)||
                        (map[y2][x1]<25);
            }
            
            public void stop(){
                
                end=false;
            }
            
            public void start(int lvl){
                
                vector=0;
                fuck.type=false;
                end=true;
                x=y=16;
                life=3;
                fall=0;
                lftnull();
                rtnull();
                ennull();
                bullnull();
                try{
                    
                    load(lvl);
                }catch(Exception e){
                    
                    menu.win.run();
                    end=false;
                }
                run();
            }
            
            private void lftnull(){
                
                for(int i=0;i<16;i++)lift[i].type=false;
            }
            
            private void rtnull(){
                
                for(int i=0;i<16;i++)rt[i]=false;
            }
            
            private void ennull(){
                
                for(int i=0;i<32;i++)en[i].type=false;
            }
            
            private void bullnull(){
                
                for(int i=0;i<32;i++)bullet[i].type=0;
            }
            
            private void load(int lvl)
                    throws Exception{
                
                try{
                    
                    DataInputStream input=new DataInputStream(
                            getClass().getResourceAsStream(
                                    "/map/Map"+lvl+".bin"));
                    for(int iy=0;iy<32;iy++){
                
                        for(int ix=0;ix<64;ix++){
                    
                            map[iy][ix]=input.readByte();
                            switch(map[iy][ix]){
                                
                                case 0x31: //генератор врага
                                    map[iy][ix]=0x1c;
                                    newEnemy(ix*16,iy*16);
                                    break;
                                    
                                case 0x32: //генератор дохлого робата
                                    map[iy][ix]=0x1c;
                                    newRobot(ix*16,iy*16);
                                    break;
                                    
                                case 0x33: //генератор финиша
                                    map[iy][ix]=0x1c;
                                    finish=(iy<<8)|ix;
                                    break;
                                    
                                case 0x35:////////////
                                    map[iy][ix]=0x1c;
                                    fuck.type=true;
                                    fuck.posx=ix*16;
                                    fuck.posy=iy*16;
                                    break;
                                    
                                case 0x12: //конструкция лифта
                                    int block=0x12;
                                    int stop;
                                    for(stop=iy;block!=0x14;stop--)
                                        block=map[stop][ix];
                                    newLift(ix*16,iy*16,stop*16+65);
                            }
                        }
                    }
                    input.close();
                }catch(IOException ioe){
                    
                    exception(ioe);
                }catch(Exception e){
                    
                    throw e;
                }
            }
            
            private void paint(){
                
                //расчитываем камеру
                camx=x+16-scrx/2;
                camy=y+32-scry/2;
                if(camx<0)camx=0;
                if(camy<0)camy=0;
                if(camx>(1024-scrx))camx=1024-scrx;
                if(camy>(512-scry))camy=512-scry;
                
                //ограничение отрисовки для карты
                int minx=camx/16;
                int maxx=(camx+scrx)/16;
                int miny=camy/16;
                int maxy=(camy+scry)/16;
                if(minx<0)minx=0;
                if(miny<0)miny=0;
                if(maxx>63)maxx=63;
                if(maxy>31)maxy=31;
                
                //карта
                for(int iy=miny;iy<=maxy;iy++){
                    
                    for(int ix=minx;ix<=maxx;ix++){
                        
                        graph.drawImage(tile[map[iy][ix]],(ix*16)-camx,
                                (iy*16)-camy,0);
                    }
                }
                
                //лифт
                for(int i=0;i<16;i++)lift[i].upd();
                
                //роботы
                for(int i=0;i<16;i++)if(rt[i])graph.drawImage(deadRobot,
                        rx[i]-camx,ry[i]-camy,0);
                
                //игрок
                if((kc==KEY_NUM5)
                        ||(kc==-5))graph.drawImage(gamer_fire[vector],
                                x-camx,y-camy,0);
                else gamer[vector].paint(graph,x-camx,y-camy);
                
                //пули & enemys
                for(int i=0;i<32;i++){
                    
                    en[i].paint();
                    if(bullet[i].type!=0){
                        
                        if(bullet[i].type==1)graph.setColor(0xFF0000);
                        else graph.setColor(0xFF);
                        graph.fillRect(bullet[i].posx-camx,bullet[i].posy-camy,
                                4,4);
                    }
                }
                boom.paint();
                
                panel.paint(graph);
                
                graph.setColor(0xAA90);
                for(int i=0;i<life;i++){
                    
                    graph.fillRect(1+i*14,scry-14,13,13);
                }
                
                if(fuck!=null)fuck.run();
            }
            
            //физика игрока
            private void phyctrl(){
                
                if(is())return;
                //////coll gamer and bullets
                for(int i=0;i<32;i++){
                    
                    if(bullet[i].type==2){
                        
                        if(bullet[i].posx>x&&
                                bullet[i].posx<x+16&&
                                bullet[i].posy>y&&
                                bullet[i].posy<y+32){
                            
                            life--;
                            if(life<0){
                                
                                
                            }
                        }
                    }
                }
                x-=lspeedx/2;
                x+=rspeedx/2;
                if(lspeedx>rspeedx){
                    
                    while(coll(x,y))x++;
                }else{
                    
                    if(lspeedx<rspeedx){
                        
                        while(coll(x,y))x--;
                    }
                }
                if(jmp){
                    
                    y-=jspeed;
                    if(jspeed>0){
                        
                        jspeed--;
                    }else{
                        
                        jmp=false;
                        fall=0;
                    }
                    if(coll(x,y)){
                        
                        jmp=false;
                        fall=0;
                        while(coll(x,y))y++;
                    }
                }else{
                    
                    y+=fall/2;
                }
                if(coll(x,y)){
                    
                    int c=fall;
                    fall=0;
                    if(c>20)oh_loh();
                    while(coll(x,y))y--;
                }else{
                    
                    if(fall<32)fall++;
                }
                if((((y/16)<<8)|(x/16))==finish){
                    
                    byte lvl=getLvl();
                    putLvl(++lvl);
                    start(lvl);
                }
                if(map[y/16+2][x/16]==0x12)activateLift(x/16,y/16+2);
            }
            
            private void keyPressed(){
                
                if(is())return;///////////////////////////я ненанижу этот мир
                int key=getKeyStates();
                if(((key&GameCanvas.LEFT_PRESSED)!=0)||
                        ((key&GameCanvas.RIGHT_PRESSED)!=0)){
                    
                    gamer[vector].next();
                }
                if((key&GameCanvas.LEFT_PRESSED)!=0){
                    
                    moveLeft();
                }else{
                    
                    if(lspeedx>0)lspeedx--;
                }
                if((key&GameCanvas.RIGHT_PRESSED)!=0){
                    
                    moveRight();
                }else{
                    
                    if(rspeedx>0)rspeedx--;
                }
                key=kc;
                kc=0;
                switch(key){
                    
                    case 50:
                    case -1:
                        y++;
                        if(coll(x,y)){
                        
                            jmp=true;
                            jspeed=6;
                        }
                        y--;
                        break;
                        
                    case 57:
                    case -7:
                        int i=REPENT.Application.this.menu.pause.run();
                        if(i==1)stop();
                        break;
                        
                    case 53:
                    case -5:
                        switch(vector){
                        
                            case 0:
                                fire(1,x+9,y+10,vector);
                                lspeedx+=3;
                                break;
                            
                            case 1:
                                fire(1,x+3,y+10,vector);
                                rspeedx+=3;
                        }
                }
            }
            
            private void moveLeft(){
                
                if(lspeedx<8)lspeedx++;
                vector=1;
            }
            
            private void moveRight(){
                
                if(rspeedx<8)rspeedx++;
                vector=0;
            }
            
            private void fire(int type,int x,int y,int vector){
                
                for(int i=0;i<32;i++){
                    
                    if(bullet[i].create(type,vector,x,y))break;
                }
            }
            
            private void newEnemy(int x,int y){
                
                for(int i=0;i<32;i++){
                    
                    if(en[i].create(x,y))break;
                }
            }
            
            private void newRobot(int x,int y){
                
                for(int i=0;i<16;i++){
                    
                    if(!rt[i]){
                        
                        rt[i]=true;
                        rx[i]=x;
                        ry[i]=y;
                        break;
                    }
                }
            }
            
            private boolean bull_coll(int x,int y){//derbmo
                
                return (x>this.x)&&
                        (x<(this.x+16))&&
                        (y>this.y)&&
                        (y<(this.y+32));
            }
            
            public void oh_loh(){ //event если ёбнулся или ранился
             
                life--;
                if(life<0){menu.go.run();
                menu.game.start(getLvl());}
            }
            
            //true если игрок на лифте блеать
            private boolean is(){
                
                for(int i=0;i<16;i++)if(lift[i].state)return true;
                return false;
            }
            
            private void newLift(int x,int y,int stop){
                
                for(int i=0;i<16;i++)if(lift[i].create(x,y,stop))break;
            }
            
            private void activateLift(int x,int y){
                
                for(int i=0;i<16;i++)if(lift[i].activate(x,y))break;
            }
            
            private class Bullet{
                
                public int posx;
                public int posy;
                public int type;
                public int vector;
                
                public Bullet(){
                    
                    type=0;
                    posx=0;
                    posy=0;
                    vector=0;
                }
                
                public boolean create(int type,int vector,int posx,int posy){
                    
                    if(this.type==0){
                        
                        this.type=type;
                        this.vector=vector;
                        this.posx=posx;
                        this.posy=posy;
                        return true;
                    }else{
                        
                        return false;
                    }
                }
                
                public void upd(){
                    
                    if(type!=0){
                        
                        if(vector==0)posx+=6;
                        else posx-=6;
                        if(posx>1024){
                            
                            type=0;
                            return;
                        }
                        if(type==1){
                            
                            for(int i=0;i<32;i++){
                             
                                if(en[i].coll(posx,posy)){
                                    
                                    if(en[i].type==false)continue;
                                    en[i].damage();
                                    type=0;
                                }
                            }
                        }else{
                            
                            if(bull_coll(posx,posy)){
                             
                                oh_loh();
                                type=0;
                            }
                        }
                        if(map[posy/16][posx/16]<25)type=0;
                    }
                }
            }
            
            private class Enemy{
                
                private int posx;
                private int posy;
                private boolean type;
                private int vector;
                private boolean jmp;
                private int jspeed;
                private int fall;
                private int rspeedx;
                private int lspeedx;
                private int life;
                private boolean fire;
                
                public Enemy(){
                    
                    posx=0;
                    posy=0;
                    type=false;
                }
                
                
                public void damage(){
                    
                    life--;
                    if(life<0)destroy();
                }
                
                //blyatb
                public boolean coll(int x,int y){
                    
                       return (x>posx)&&
                            (x<(posx+16))&&
                            (y>posy)&&
                            (y<(posy+32));
                }
                
                
                public boolean create(int posx,int posy){
                    
                    if(type==false){
                        
                        life=5;
                        type=true;
                        this.posx=posx;
                        this.posy=posy;
                        vector=1;
                        jmp=false;
                        jspeed=0;
                        fall=0;
                        rspeedx=0;
                        lspeedx=0;
                        return true;
                    }else{
                        
                        return false;
                    }
                }
                
                public void paint(){
                    
                    if((type==true)&&((posx+16)>camx)&&(posx<(camx+scrx))){
                        
                        if(fire){
                            
                            fire=false;
                            graph.drawImage(en__[vector],posx-camx,posy-camy,0);
                        }else{
                            
                            en_[vector].paint(graph,posx-camx,posy-camy);
                        }
                    }
                }
                
                public void upd(){
                    
                    if((type==true)&&((posx+16)>camx)&&(posx<(camx+scrx))){
                        
                        if((posy>(y-32))&&(posy<(y+32))){
                            
                            en_[vector].next();
                            if((posx+16)<x){
                                
                                moveRight();
                            }else{
                                
                                if(rspeedx>0)rspeedx--;
                            }
                            if(posx>(x+16)){
                                
                                moveLeft();
                            }else{
                                
                                if(lspeedx>0)lspeedx--;
                            }
                            if(Math.abs(rnd.nextInt()%75)==0){
                            
                                fire=true;
                                switch(vector){
                        
                                    case 0:
                                        fire(2,posx+9,posy+10,vector);
                                        lspeedx+=3;
                                        break;
                            
                                    case 1:
                                        fire(2,posx+3,posy+10,vector);
                                        rspeedx+=3;
                                }
                            }
                        }
                        posx-=lspeedx/2;
                        posx+=rspeedx/2;
                        if(lspeedx>rspeedx){
                    
                            while(REPENT.Application.Game.this.coll(posx,posy))
                                posx++;
                        }else{
                    
                            if(lspeedx<rspeedx){
                        
                                while(
                                        REPENT.Application.Game.this.coll(
                                                posx,
                                                posy))
                                    posx--;
                            }
                        }
                        if(jmp){
                    
                            posy-=jspeed;
                            if(jspeed>0){
                        
                                jspeed--;
                            }else{
                        
                                jmp=false;
                                fall=0;
                            }
                            if(coll(posx,posy)){
                        
                                jmp=false;
                                fall=0;
                                while(coll(posx,posy))posy++;
                            }
                        }else{
                    
                            posy+=fall/2;
                        }
                        if(REPENT.Application.Game.this.coll(posx,posy)){
                            
                            if(fall>30)damage();
                            fall=0;
                            while(REPENT.Application.Game.this.coll(posx,posy))
                                posy--;
                        }else{
                            
                            if(fall<32)fall++;
                        }
                    }
                }
                
                private void destroy(){
                    
                    type=false;
                    boom.activate(posx,posy);
                }
                
                private void moveLeft(){
                    
                    if(lspeedx<6)lspeedx++;
                    vector=1;
                }
                
                private void moveRight(){
                    
                    if(rspeedx<6)rspeedx++;
                    vector=0;
                }
            }
            
            private class Lift{
                
                private int pos; //0x0X_0Y
                public boolean state;
                private boolean type;
                private int posx;
                private int posy;
                //true - вверх, false - вниз (изничально все вверх)
                private boolean vector;
                private int start;
                private int stop;
                /////спим как только происходи деактивация (5 sec)
                private long sleep;
                
                public boolean create(int x,int y,int stop){
                    
                    if(!type){
                        
                        pos=((x/16)<<8)|(y/16);
                        type=true;
                        state=false;
                        posx=x;
                        start=posy=y;
                        vector=false;
                        this.stop=stop;
                        sleep=0;
                        return true;
                    }else{
                        
                        return false;
                    }
                }
                
                public boolean activate(int x,int y){
                    
                    if(state)return false;
                    if((System.currentTimeMillis()-sleep)<1000)return false;
                    if(((x<<8)|y)==pos){
                    
                        //System.out.println("uuu");
                        REPENT.Application.Game.this.x=
                                (REPENT.Application.Game.this.x/16)*16;
                        lspeedx=rspeedx=0;////////cyka
                        fall=0;
                        {map[y][x]=0x1c;}
                        state=true;
                        vector=!vector;
                        return true;
                    }else{
                        
                        //System.out.println("else");
                        return false;
                    }
                }
                
                public void deactivate(){
                    
                    state=false;
                    map[posy/16][posx/16]=0x12;
                    sleep=System.currentTimeMillis();
                    pos=((posx/16)<<8)|(posy/16);
                }
                
                public void upd(){
                    
                    if(type&&
                            ((posx+16)>camx)&&(posx<(camx+scrx))&&
                            (((start+16)>camy)||
                                    (posy+16)>camy)&&
                            ((start<(camy+scry))||
                                    (posy<(camy+scry)))){
                        
                        if(state){
                            
                            if(vector){
                                
                                posy-=8;
                                y-=8;
                                if(posy<=stop){
                                    
                                    deactivate();
                                }
                            }else{
                                
                                posy+=8;
                                y+=8;
                                if(posy>=start){
                                    
                                    deactivate();
                                }
                            }
                        }
                        int n=(posy/16)*16+16;
                        for(int i=n;i<start+16;i+=16)
                            graph.drawImage(tile[0x15],posx-camx,i-camy,0);
                        graph.drawImage(tile[0x12],posx-camx,posy-camy,0);
                    }
                }
            }
            
            private class Boom{
                
                private Animation a;
                private boolean type;
                private int posx;
                private int posy;
                private int step;
                
                public Boom(){
                    
                    try{
                        
                        a=Animation.createAnimation("/gfx/Boom.png",16,125);
                    }catch(IOException ioe){
                        
                        exception(ioe);
                    }
                }
                
                public void paint(){
                    
                    if(!type)return;
                    //System.out.println("sd");
                    a.paint(graph,posx-camx,posy-camy);
                    a.next();
                    step++;
                    if(step>=10)deactivate();
                }
                
                public void activate(int x,int y){
                    
                    type=true;
                    step=0;
                    posx=x;
                    posy=y;
                }
                
                private void deactivate(){
                    
                    type=false;
                }
            }
            
            private class Knopka{
                
                public int posx;
                public int posy;
                private boolean state;
                public boolean type;
                private Image tru;
                private Image fols;
                private Image til;
                
                public Knopka(int x,int y){
                    
                    type=false;
                    posx=x;
                    posy=y;
                    state=false;
                    try{
                        
                        tru=Image.createImage("/gfx/Tru.png");
                        fols=Image.createImage("/gfx/Fols.png");
                        til=Image.createImage("/gfx/Til.png");
                    }catch(IOException ioe){
                        
                        exception(ioe);
                    }
                }
                
                public void run(){
                    
                    if(!type)return;
                    if(posx+16>camx&&
                            posx<camx+scrx&&
                            posy+16>camy&&
                            posy<camy+scry){
                        
                        graph.drawImage(til,
                                (posx-camx),
                                (posy-camy)+32,0);
                        if(state)graph.drawImage(tru,posx-camx,posy-camy+16,0);
                        else graph.drawImage(fols,posx-camx,posy-camy+16,0);
                        if(((x/16*16)==posx)&&((y/16*16)==posy)){
                            
                            state=true;
                            return;
                        }
                        if(state){
                            
                            state=false;
                            menu.win.start();
                            menu.win.run();
                            end=false;
                        }
                    }
                }
            }
        }
    }
}
